﻿using Syncfusion.ListView.XForms.Control.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Internals;

namespace SfListViewSamples
{
    [Preserve(AllMembers = true)]
    public partial class DataTemplateSelector : ContentPage
    {
        ViewModel VM = new ViewModel();
        #region ListViewDataTemplateSelector
        public DataTemplateSelector()
        {
            InitializeComponent();
            //listView.ItemTapped += ListView_ItemTapped;
            //listView.Loaded += ListView_Loaded;
            var scroll=listView.GetScrollView();
        }


        private void ListView_Loaded(object sender, Syncfusion.ListView.XForms.ListViewLoadedEventArgs e)
        {
            Device.BeginInvokeOnMainThread(async () =>
            {
                VM.IsLoading = true;
                listView.IsVisible = false;
                listView.LayoutManager.ScrollToRowIndex(listView.DataSource.DisplayItems.Count - 1, true);
                await Task.Delay(5000);
                VM.IsLoading = false;
                listView.IsVisible = true;
            });
        }

        #endregion

        private void ListView_ItemTapped(object sender, Syncfusion.ListView.XForms.ItemTappedEventArgs e)
        {
            if ((e.ItemData as MessageInfo).TemplateType == TemplateType.OutGoingText)
                (e.ItemData as MessageInfo).TemplateType = TemplateType.IncomingText;
            else
                (e.ItemData as MessageInfo).TemplateType = TemplateType.OutGoingText;
            listView.RefreshView();
        }
    }
}
